Unit
    Browse;
{
   '  ⠡筮 ।஢. Without Turbo Vision.
  Copyright (c) V Kulimov 1992 year.
}

Interface

Uses
    Crt, Arc;

Type
  PBrowse = ^TBrowse;
  TBrowse = Object
    xCol,          { ᨢ p.  }
    X             : Array[1..20] of Byte; { ᨢ p. 権 }
    Y1, Y2,
    yBegin,
    maxX, maxCol,
    xEnd, xBegin,
    Row, Col, Ass : Byte;
    Tek, Sc       : Word;
    RecVisible    : Boolean;
    ScrName       : String; {  p  p Init'e }
    Constructor Init;
    Procedure   PrRec(Y,t: Word); Virtual;
    Procedure   DelRecord; Virtual;
    Function    Edit(K: Byte): Boolean; Virtual;
    Destructor  Done;
    Procedure   PrScr(t: Word);
    Procedure   RecNo(t: Word);
    Procedure   Left;
    Procedure   Right;
    Procedure   Tab;
    Function    GoHome       : Boolean;
    Function    AllRight     : Byte;
    Function    Up           : Boolean;
    Function    Down         : Boolean;
    Procedure   RecNumber;
  End;

Implementation

Uses
  Objects;

Constructor TBrowse.Init;
Var
  S, P: String;
  T: Text;
  i,k,
  j,h: Byte;
Begin
  Assign(T, ScrName);
  Reset(T);
  TextColor(Yellow);
  TextBackGround(Blue);
  GotoXY(1,1);
  h := 0;
  yBegin := 1;
  While Not Eof(T) do
  Begin
    ReadLn(T, S);
    Inc(h);
    K := 0;
    if S[1] = '#' then
    begin
       WriteLn;
       Inc(yBegin);
    End
    else
    For i := 1 to Byte(S[0]) do
    if S[i] = #$20 then
    Begin
       GotoXY(i, WhereY);
       Inc(k);
    End
    Else
    Begin
      if Pos('@', S) <> 0 then
      Begin
        Delete(S, Pos('@', S), 1);
        GotoXY(WhereX + 1, WhereY);
        Y1 := h;
        xEnd   := Length(S)  - 1;
        xBegin := Pos('',S) + 1;
        j := 0;
        While True do
        Begin
          Inc(j);
          Str(j, P);
          if Pos(P, S) <> 0 then
            X[j] := Pos(P, S)
          else
            Break;
          S[Pos(P, S)] := ' ';
        End;
        MaxX := j - 1;
        P := S;
        j := 0;
        While Pos('', P) <> 0 do
        Begin
          Inc(j);
          xCol[j] := Pos('', P);
          P[Pos('', P)] := ' ';
        End;
        MaxCol := j;
      End;
      Delete(S, 1, k);
      WriteLn(S);
      Break;
    End;
  End;
  Y2  := h - 1;
  Ass := 1;
  Shadow(yBegin, xBegin - 1, h, xEnd + 1);
  Close(T);
End;


Destructor TBrowse.Done;
Begin
  Abstract;
End;


Procedure TBrowse.DelRecord;
Begin
  Abstract;
End;


Procedure TBrowse.RecNo(T: Word);
Var
   O : String;
Begin
     CursorOff;
     GotoXY(xEnd-5,yBegin);
     TextColor(Black);
     TextBackGround(Green);
     Str(T:4,o);
     Write(Chr(250),o,Chr(250));
     TextColor(Yellow);
     TextBackGround(Blue);
     CursorOn;
     GotoXY(Col,Row)
End;


Procedure TBrowse.PrRec(Y,t : Word);
Begin
  Abstract;
End;

Procedure TBrowse.PrScr(t:Word);
Var
   i : Word;
Begin
     ScrollUp(xBegin, y1, xEnd, y2, 0);
     For i := 0 to Y2 - Y1 do
     Begin
          PrRec(Y1+i,t);
          Inc(t);
     end;
     CursorOn;
     GoToXY(Col,Row);
end;


Function TBrowse.Edit(K:Byte): Boolean;
Begin
  Abstract
End;

Function TBrowse.AllRight:
                         Byte;
Const
     Menu : Array[1..3] of String[12] =
            ( '          ',
              '    H     ',
              ' p '
            );
     Coor: Array[1..3] of Byte = ( 5 , 18 , 31 );

Var
   Ch,i         : Byte;
   Choice       : Byte;
   D            : ScrPointer;
Begin
     CursorOff;
     GetMem(D,4000);
     Move(Mem[ScrAddr:0000],D^,4000);

     MyWindow(8, 16, 14, 66, Double, Black, 7);
     GoToXY(7,2);
     Write('  p!   Cp ?');
     TextColor(White);
     TextBackGround(Red);
     GoToXY(Coor[1],4);
     Write(Menu[1]);

     TextColor(Black);
     TextBackGround(7);
     Write('');
     GoToXY(Coor[1]+1,5);
     Write('');
     For i := 2 to 3 do
     begin
          GoToXY(Coor[i],4);
          Write(Menu[i]);
     end;

     Choice := 1;
     Repeat
           Ch := ReadK;
           GoToXY(Coor[Choice],4);
           Write(Menu[Choice],' ');
           GoToXY(Coor[Choice]+1,5);
           Write(Space(12));
           Case Ch of

                77,9 : Begin
                            if Choice = 3 then Choice := 1
                            else Inc(Choice);
                        end;
                75   : Begin
                            if Choice = 1 then Choice := 3
                            else Dec(Choice);
                        end;
                Esc   : Choice := 3;
           end;
           if (Ch = Return) or (Ch = Esc) then
           begin
                TextColor(Black);
                TextBackGround(7);
                GoToXY(Coor[Choice],4);
                Write(' ');
                GoToXY(Coor[Choice]+1,5);
                Write(Space(12));
                TextColor(White);
                TextBackGround(Red);
                GoToXY(Coor[Choice]+1,4);
                Write(Menu[Choice]);
           end
           else
           begin
                TextColor(White);
                TextBackGround(Red);
                GoToXY(Coor[Choice],4);
                Write(Menu[Choice]);
                TextColor(Black);
                TextBackGround(7);
                Write('');
                GoToXY(Coor[Choice]+1,5);
                Write('');
           end;

     Until (Ch = Return) or (Ch = Esc);

     Window(1,1,80,25);
     if (Choice = 1) or (Choice = 2) then
     begin
          AllRight := Choice;
          FreeMem(D,4000);
          Exit
     end;

     Move(D^,Mem[ScrAddr:0000],4000);
     FreeMem(D,4000);
     TextColor(Yellow);
     TextBackGround(Blue);
     CursorOn;
     GoToXY(Col,Row);
     if Choice = 3 then Choice := 0;
     AllRight := Choice;
End;



Procedure TBrowse.Left;
begin
  if Ass <> 1 then
  Begin
     Dec(Ass);
     Col := X[Ass];
  End;
  GoToXY(Col,Row);
end;


Procedure TBrowse.Right;
begin
  if Ass <> MaxX then
  Begin
    Inc(Ass);
    Col := X[Ass]
  End;
  GoToXY(Col,Row);
end;

Procedure TBrowse.Tab;
Begin
  if Ass <> MaxX then
    Inc(Ass)
  else
    Ass := 1;
  Col := X[Ass];
  GoToXY(Col,Row);
end;

Function TBrowse.Up;
Begin
     If ( Tek <> 1 ) then
     Begin
          Dec(Tek);
          if Row <> Y1 then
               Dec(Row)
          else
          Begin
               ScrollDown(xBegin , y1, xEnd, y2, 1);
               PrRec(y1,Tek);
          End;
          Up := False
     end
     else
     Begin
          Sound(1000);
          GoToXY(1,25);
          TextColor(BLACK);
          TextBackGround(WHITE);
          Write(Space(79));
          GoToXY(28,25);
          Write(' p !!');
          TextColor(YELLOW);
          TextBackGround(BLUE);
          Delay(20);
          NoSound;
          Up := True;
     end;
     if RecVisible then RecNo(Tek);
     GotoXY(Col,Row);
end;

Function  TBrowse.GoHome: Boolean;
Begin
     If Tek <> 1 then
     begin
          CursorOff;
          Tek := 1;
          Row := Y1;
          GoHome := False;
          if Sc > Y2 - Y1 then
             PrScr(Tek);
          CursorOn;
     end
     else
     Begin
          Sound(1000);
          GoToXY(1,25);
          TextColor(BLACK);
          TextBackGround(WHITE);
          Write(Space(79));
          GoToXY(28,25);
          Write(' p !!');
          TextColor(YELLOW);
          TextBackGround(BLUE);
          Delay(20);
          NoSound;
          GoHome := True;
     end;
     if RecVisible then RecNo(Tek);
     GotoXY(Col,Row);
end;

Function TBrowse.Down: Boolean;
Begin
     If ( Tek <> Sc ) then
     Begin
          Inc(Tek);
          if Row <> Y2 then
               Inc(Row)
          else
          Begin
               ScrollUp(xBegin, y1, xEnd, y2, 1);
               PrRec(Y2,Tek);
          End;
          Down := False;
     end
     else
     Begin
          Sound(1000);
          GoToXY(1,25);
          TextColor(BLACK);
          TextBackGround(WHITE);
          Write(Space(79));
          GoToXY(28,25);
          Write(' ᫥ !!');
          TextColor(YELLOW);
          TextBackGround(BLUE);
          Delay(20);
          NoSound;
          Down := True;
     end;
     if RecVisible then RecNo(Tek);
     GotoXY(Col,Row);
end;

Procedure TBrowse.RecNumber;
Begin
  if RecVisible then
  Begin
    Box(yBegin, Xend-5, YBegin, xEnd,Double,Yellow+16);
    GotoXY(Col,Row);
  End
  Else
    RecNo(Tek);
  RecVisible := Not RecVisible;
End;

end.
